; IPC5 Domain: TPP ComplexPreference
; Authors: Alfonso Gerevini and Alessandro Saetti
; temporal features removed and buy action modified by Amanda Coles and Andrew Coles

(define (domain TPP-MetricTimePreferences)
(:requirements :typing :fluents :adl :constraints :preferences) 
(:types depot market - place 
	truck goods - locatable)

(:predicates (connected ?p1 ?p2 - place)
	     (at ?t - truck ?p - place))

(:functions (on-sale ?g - goods ?m - market)
	    (ready-to-load ?g -goods ?m - place)
	    (drive-cost ?p1 ?p2 - place)
	    (drive-time ?p1 ?p2 - place)
	    (loaded ?g - goods ?t - truck)
	    (stored ?g - goods)		
	    (price ?g - goods ?m - market)
	    (bought ?g - goods)
	    (request ?g - goods)
	    (total-cost)
	    (rebate-rate ?m - market))

(:action drive
 :parameters (?t - truck ?from ?to - place)
 :precondition (and (preference p-drive (forall (?g - goods) 
                                             (< (ready-to-load ?g ?from) 1)))
		 (at ?t ?from) 
		 (connected ?from ?to))
 :effect (and (not (at ?t ?from)) 
		   (at ?t ?to)
	           (increase (total-cost) (drive-cost ?from ?to))
	  )
)

(:action load
 :parameters (?g - goods ?t - truck ?m - market)
 :precondition (and 
	      (>= (ready-to-load ?g ?m) 1) 
	      (at ?t ?m))
 :effect (and 
	      (increase (loaded ?g ?t) 1)
	      (decrease (ready-to-load ?g ?m) 1)))

(:action unload
 :parameters (?t - truck ?g - goods ?d - depot)
 :precondition (and 
		(>= (loaded ?g ?t) 1) 
		(at ?t ?d))
 :effect (and 
	      (increase (stored ?g) 1)
	      (decrease (loaded ?g ?t) 1))
)

(:action buy
 :parameters (?t - truck ?g - goods ?m - market)
 :precondition (and 
		    (>= (on-sale ?g ?m) 1)
		    (< (bought ?g) (request ?g))
		    (at ?t ?m))
 :effect (and 
	     (decrease (on-sale ?g ?m) 1)
	     (increase (bought ?g) 1)
	     (increase (ready-to-load ?g ?m) 1)
	     (increase (total-cost) (price ?g ?m)))
)

)